/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */

#include <vector>
#include "blockstructure.h"

using std::vector;

blockstructure::blockstructure() { // constructor
};

blockstructure::~blockstructure() { // deconstructor
};

/* Multiplier branch of a block structure
 * --------------------------------------------------
 * multiplies the output signal with the input signal
 * 
 */
void blockstructure::negate(float *in, unsigned long framelength) {
    // inverts sign of input signal
    for(int i = 0; i < framelength; i++) {
        in[i] = -in[i];
    }
}

void blockstructure::decimate(float *in, float *out, unsigned int M, int offset, unsigned long framelength) {
    // forward each Mth sample
    int j = 0;
    for(int i = offset; i < framelength; i+=M) {
        out[j++] = in[i];
    }
}

void blockstructure::interpolate(float *in, float *out, unsigned int L, int offset, unsigned long framelength) {
    // do interpolation by adding zeros
    int j;
    j = L*framelength-1;
    for(int i = framelength-1; i >= 0; i--) 
    {
        for(int k = L-1; k >= 0; k--)    
        {
            if (k==offset)
                out[j--] = in[i];
            else
               out[j--] = 0.0;
        }
    }
}